ProjetMes/Models/AbstractEntity.cs
namespace Projet_mes.Models
{
    public abstract class AbstractEntity
    {        public long Id { get; set; }
    }
}

ProjetMes/Models/ErrorViewModel.cs
namespace Projet_mes.Models
{
    public class ErrorViewModel
    {
        public string? RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

ProjetMes/Models/Genre.cs
using Projet_mes.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.SqlTypes;

namespace Projet_mes.Models
{
    [Table("genres")]
    public class Genre : AbstractEntity
    {
        [Required]
        [MaxLength(100)]
        public string Name { get; set; }

        public ICollection<Movie> Movies { get; set; }
    }
}

ProjetMes/Models/Movie.cs
using Projet_mes.Models;
using System.Collections.Generic;
using System.Xml.Linq;
using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Projet_mes.Models
{
	[Table("movies")]
	public class Movie : AbstractEntity
	{
		[Required]
		[Column("title_vf")]
		public string? TitleVf { get; set; }

		[Column("title_vo")]
		public string? TitleVo { get; set; }

		[Required]
		public int Duration { get; set; }

		[Required]
		[Column("release_date")]
		public DateTime? ReleaseDate { get; set; }

		[Column("movie_poster")]
		public string? MoviePoster { get; set; }

		[Column("ident_video")]
		public string? IdentVideo { get; set; }

		public string? Summary { get; set; }

		public Nation? Nationality { get; set; }

		public Genre? Genre { get; set; }

		public ICollection<Participant> Realisators { get; set; }

		public ICollection<Participant> Actors { get; set; }
	}
}

ProjetMes/Models/Nation.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Projet_mes.Models
{
	[Table("nations")]
	public class Nation : AbstractEntity
	{
		[Required]
		[MaxLength(100)]
		public string Name { get; set; }

		public ICollection<Participant> Actors { get; set; }

		public ICollection<Movie> Movies { get; set; }
	}
}

ProjetMes/Models/Participant.cs
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Projet_mes.Models
{
	[Table("participants")]
	public class Participant : AbstractEntity
	{
		[Required]
		[MaxLength(50)]
		public string? FirstName { get; set; }


		[MaxLength(50)]
		public string? LastName { get; set; }

		[Required]
		public DateTime? BirthDate { get; set; }

		public DateTime? DeathDate { get; set; }

		public Nation Nationality { get; set; }

		public ICollection<Movie> MoviesRealisators { get; set; }

		public ICollection<Movie> MoviesActors { get; set; }
	}
}

ProjetMes/ViewModels/MovieViewModel.cs
using Microsoft.AspNetCore.Mvc.Rendering;
using Projet_mes.Models;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Projet_mes.ControlViews
{
    public class MovieViewModel
    {
        public Movie Movie { get; set; }

        public IList<Genre> Genres { get; set; }

        public IList<Nation> Nations { get; set; }

        public IFormFile Poster { get; set; }
    }
}

ProjetMes/Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using Projet_mes.Models;
using Projet_mes.Repositories;
using System.Collections.Generic;
using System.Diagnostics;

namespace Projet_mes.Controllers
{
    public class HomeController : Controller
    {
        private readonly MovieDbContext _context;
        private readonly MovieRepository _movieRepository;

        public HomeController(MovieDbContext context)
        {
            _context = context;
            _movieRepository = new MovieRepository(_context);
        }

        public IActionResult Index()
        {
            IList<Movie> lstMovies = _movieRepository.FindAll();
            return View(lstMovies);
        }

        public IActionResult Detail(long id)
        {
            return View(_movieRepository.FindById(id));
		}
		public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

ProjetMes/Controllers/MovieController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Projet_mes.ControlViews;
using Projet_mes.Models;
using Projet_mes.Repositories;
using Projet_mes.Tools;
using System.Drawing;


namespace Projet_mes.Controllers
{
    public class MovieController : Controller
    {
        private readonly MovieDbContext _dbContext;
        private MovieRepository _movieRepository;
        private NationRepository _nationRepository;
        private GenreRepository _genreRepository;

        public MovieController(MovieDbContext context)
        {
            _dbContext = context;
            _movieRepository = new MovieRepository(_dbContext);
            _nationRepository = new NationRepository(_dbContext);
            _genreRepository = new GenreRepository(_dbContext);
        }

        public IActionResult Index()
        {
            return View(_movieRepository.FindAll());
        }

        [HttpGet]
        public IActionResult Create()
        {
            MovieViewModel mmv = new MovieViewModel();
            mmv.Genres = _genreRepository.FindAll();
            mmv.Nations = _nationRepository.FindAll();
            return View("CreateEdit", mmv);
        }

        [HttpPost]
        public IActionResult Create(MovieViewModel mmv)
        {
            if (ModelState.IsValid)
            {
                return View("CreateEdit", ModelState);
            }
            mmv.Movie.MoviePoster=UploadTools.Upload(mmv.Poster,mmv.Movie.TitleVf);
            mmv.Movie.Nationality=_nationRepository.FindByName(mmv.Movie.Nationality.Name);
            mmv.Movie.Genre = _genreRepository.FindByName(mmv.Movie.Genre.Name);
            _movieRepository.Create(mmv.Movie);
            _movieRepository.Save();
            return Redirect("~/Movie");
        }
    
        public IActionResult Delete(long id)
        {
            Movie movie= _movieRepository.FindById(id);
            UploadTools.Delete(movie.MoviePoster);
            _movieRepository.Delete(id);
            _movieRepository.Save();
            return Redirect("~/Movie");
        }
    
    }
}

ProjetMes/Views/Home/Detail.cshtml
@{
    ViewData["Title"] = "Detail";
}
@model Movie

<div class="card mb-3 small shadow offset-md-1 col-md-10">
    <div class="row g-0">
        <div class="col-md-3">
            <img src=~/image/@Model.MoviePoster class="img-fluid rounded-start">
        </div>
        <div class="col-md-9">
            <div class="card-body">
                <h2 class="card-title">@Model.TitleVf</h2>
                <hr />
                <p class="text-secondary h4 my-2"> @Model.TitleVo</p>

                <p class="fs-5">
                    <span class="mx-3 badge bg-secondary">@Model.ReleaseDate.Value.Year</span> <span class="mx-3 badge bg-secondary">@Model.Nationality.Name</span> <span class="mx-3 badge bg-secondary">@Model.Genre.Name</span> <span class="mx-2
3 badge bg-secondary">@Model.Duration minutes</span>
                </p>
                @if(Model.Realisators.Count>0)
                {
                <p class="card-text h5">
                    Réalisateur:
                    @foreach (var real in Model.Realisators)
                    {
                        <a class="mr-4">@real.FirstName @real.LastName</a>
                    }
                </p>
                }
                @if(Model.Actors.Count > 0)
                {
                    <p class="card-text h5">
                        Acteurs:
                        @foreach (var act in Model.Actors)
                        {
                            <a class="mr-4">@act.FirstName @act.LastName</a>
                        }
                    </p>
                }
                <p class="card-text h5">@Model.Summary</p>
            </div>
        </div>
    </div>
</div>
<a class="offset-md-5 col-md-2 btn btn-primary my-5" asp-controller="Home" asp-action="Index">Retour</a>

ProjetMes/Views/Home/Index.cshtml
@{
	ViewData["Title"] = "MovieStore";
}
@model List<Movie>
<div class="row row-cols-1 row-cols-md-4 row-cols-lg-6 g-4">
	@foreach (var movie in Model)
	{
		
		<div class="col">
			<div class="card h-100 shadow-sm">
				<img src="~/image/@movie.MoviePoster" class="card-img-top img-thumbnail" alt="Affiche: @movie.TitleVf">
				<div class="card-body">
					<a asp-controller="Home" asp-action="Detail" asp-route-id="@movie.Id" class="fw-bold text-dark text-decoration-none stretched-link">
						<h6 class="card-title text-center">@movie.TitleVf</h6></a>

					<p class="card-text text-center text-muted"><small>@movie.Nationality.Name @movie.ReleaseDate.Value.Year @movie.Duration&#160;min</small></p>

				</div>
				<div class="card-footer text-center text-muted fw-bold">
					@movie.Genre.Name
				</div>
			</div>
			</div>
		
	}
</div>

ProjetMes/Views/Movie/CreateEdit.cshtml
@using Projet_mes.ControlViews;
@{
    ViewData["Title"] = "Ajout Film";
}
@model MovieViewModel

<h1>Ajout Film</h1>
<form asp-asp-controller="Movie" asp-action="Create" method="post" enctype="multipart/form-data">
    <div class="mb-1">
        <label asp-for="Movie.TitleVf" class="form-label">Titre</label>
        <input asp-for="Movie.TitleVf" class="form-control" />
        <span asp-validation-for="Movie.TitleVf"></span>
    </div>
    <div class="mb-1">
        <label asp-for="Movie.TitleVo" class="form-label">Titre VO</label>
        <input asp-for="Movie.TitleVo" class="form-control" type="text" />
        <span asp-validation-for="Movie.TitleVo"></span>
    </div>
    <div class="mb-1">
        <label asp-for="Movie.Duration" class="form-label">Durée (en minute)</label>
        <input asp-for="Movie.Duration" class="form-control" type="number" />
        <span asp-validation-for="Movie.Duration"></span>
    </div>
    <div class="mb-1">
        <label asp-for="Movie.ReleaseDate" class="form-label">Date de sortie</label>
        <input asp-for="Movie.ReleaseDate" class="form-control" type="date" />
        <span asp-validation-for="Movie.ReleaseDate"></span>
    </div>

    <div class="mb-1">
        <label asp-for="Poster" class="form-label">Affiche</label>
        <input asp-for="Poster" class="form-control" type="file" />
        <span asp-validation-for="Poster"></span>
    </div>
    <div class="mb-1">
        <label asp-for="Movie.IdentVideo" class="form-label">Identifiant Video</label>
        <input asp-for="Movie.IdentVideo" class="form-control" type="text" />
        <span asp-validation-for="Movie.IdentVideo"></span>
    </div>
    <div class="mb-1">
        <label asp-for="Movie.Genre.Name" class="form-label">Genre</label>
        <input asp-for="Movie.Genre.Name" class="form-control" list="genres" />
        <datalist id="genres">
            @foreach (var genre in Model.Genres)
            {
                <option>@genre.Name</option>
            }
        </datalist>
        <span asp-validation-for="Movie.Genre.Name"></span>
    </div>
    <div class="mb-1">
        <label asp-for="Movie.Nationality.Name" class="form-label">Nation</label>
        <input asp-for="Movie.Nationality.Name" class="form-control" list="nationality"/>
        <datalist id="nationality">
            @foreach(var nation in Model.Nations)
            {
                <option>@nation.Name</option>
            }
        </datalist>
        <span asp-validation-for="Movie.Nationality.Name"></span>
    </div>
    <div class="mb-1">
        <label asp-for="Movie.Summary" class="form-label">Résumé</label>
        <textarea asp-for="Movie.Summary" rows="4" cols="50">
        </textarea>
    </div>
    <button type="submit" class="btn btn-primary offset-md-4 col-md-4">Confirmer</button>
</form>

ProjetMes/Views/Movie/Index.cshtml
@{
    ViewData["Title"] = "Films";
}
@model List<Movie>
    <h1 class="text-center">Films</h1>
    <a asp-controller="Movie" asp-action="Create" class="btn btn-sm btn-outline-secondary mt-4">Ajouter articles</a>
    <a asp-controller="Movie" asp-action="" class="btn btn-sm btn-outline-secondary mt-4 mx-3">>Export .csv</a>
    <table class="table">
        <thead>
            <tr>
                <th>Titre</th>
                <th>Durée</th>
                <th>Année</th>
                <th>Genre</th>
                <th>Nationalité</th>
                <th>Id Vidéo</th>
            </tr>
        </thead>
        <tbody>
           @foreach(Movie movie in Model)
           {
                <tr>
                    <td>@movie.TitleVf</td>
                    <td>@movie.Duration</td>
                    <td>@movie.ReleaseDate.Value.Year</td>
                    <td>@movie.Genre.Name</td>
                    <td>@movie.Nationality.Name</td>
                    <td>@movie.IdentVideo</td>
                    <td>
                        <a asp-controller="Movie" asp-action="Update" asp-route-id="@movie.Id" class="btn btn-primary btn-sm">Modifier</a>
                        <a asp-controller="Movie" asp-action="Delete" asp-route-id="@movie.Id" class="btn btn-danger btn-sm">  Supprimer</a>
                    </td>
                </tr>
            }
        </tbody>
    </table>

ProjetMes/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="fr">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <!-- <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />-->
    <!--<link rel="stylesheet" href="~/Projet_mes.styles.css" asp-append-version="true" />-->
    <title>@ViewData["Title"]</title>
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-lg navbar-dark bg-dark mb-5 sticky-top">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">
                    <img src="~/image/brand.png" width="45">
                    MovieStore
                </a>

                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="container-fluid">
                    <div class="collapse navbar-collapse" id="navbarSupportedContent">
                        <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                        <li class="nav-item">
                            <a class="nav-link" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" asp-area="" asp-controller="Movie" asp-action="Index">Films</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <main class="container-fluid">
            @RenderBody()
    </main>
    <footer class="mt-auto mt-5">
        <hr />
        <p class="text-center small">MovieStore - D&eacute;cembre 2022 - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>